import 'liveConsultation.m.dart';

class ASRResultDTO {
	bool isComplete;
	String? content;

	ASRResultDTO({
		this.isComplete = false,
		this.content,
	});

	factory ASRResultDTO.fromJson(Map<String, dynamic> map) {
		return ASRResultDTO( 
			isComplete: map['IsComplete'],
			content: map['Content'],
		);
	}

	Map<String, dynamic> toJson() {
		final map = Map<String, dynamic>();
		map['IsComplete'] = isComplete;
		if(content != null)
			map['Content'] = content;
		return map;
	}
}

class CommitASRInfoRequest extends TokenRequest{
	String? url;
	String? fileType;

	CommitASRInfoRequest({
		this.url,
		this.fileType,
		String? token,
	}) : super(
			token: token,
		);

	factory CommitASRInfoRequest.fromJson(Map<String, dynamic> map) {
		return CommitASRInfoRequest( 
			url: map['Url'],
			fileType: map['FileType'],
			token: map['Token'],
		);
	}

	Map<String, dynamic> toJson() {
		final map = super.toJson();
		if(url != null)
			map['Url'] = url;
		if(fileType != null)
			map['FileType'] = fileType;
		return map;
	}
}


