class UpdateServerInfoRequest {
	List<String >? codes;

	UpdateServerInfoRequest({
		this.codes,
	});

	factory UpdateServerInfoRequest.fromJson(Map<String, dynamic> map) {
		return UpdateServerInfoRequest( 
			codes: map['Codes'] != null ? map['Codes'].cast<String>().toList() : null,
		);
	}

	Map<String, dynamic> toJson() {
		final map = Map<String, dynamic>();
		if(codes != null)
			map['Codes'] = codes;
		return map;
	}
}

class ServerInfoDTO {
	String? name;
	String? host;

	ServerInfoDTO({
		this.name,
		this.host,
	});

	factory ServerInfoDTO.fromJson(Map<String, dynamic> map) {
		return ServerInfoDTO( 
			name: map['Name'],
			host: map['Host'],
		);
	}

	Map<String, dynamic> toJson() {
		final map = Map<String, dynamic>();
		if(name != null)
			map['Name'] = name;
		if(host != null)
			map['Host'] = host;
		return map;
	}
}

class QueryServerInfoRequest {

	QueryServerInfoRequest();

	factory QueryServerInfoRequest.fromJson(Map<String, dynamic> map) {
		return QueryServerInfoRequest( 
		);
	}

	Map<String, dynamic> toJson() {
		final map = Map<String, dynamic>();
		return map;
	}
}

class BaseServerResult {
	int code;

	BaseServerResult({
		this.code = 0,
	});

	factory BaseServerResult.fromJson(Map<String, dynamic> map) {
		return BaseServerResult( 
			code: map['Code'],
		);
	}

	Map<String, dynamic> toJson() {
		final map = Map<String, dynamic>();
		map['Code'] = code;
		return map;
	}
}

class EchoResult extends BaseServerResult{

	EchoResult({
		int code = 0,
	}) : super(
			code: code,
		);

	factory EchoResult.fromJson(Map<String, dynamic> map) {
		return EchoResult( 
			code: map['Code'],
		);
	}

	Map<String, dynamic> toJson() {
		final map = super.toJson();
		return map;
	}
}

class UpdateServerIPListRequest {
	String? name;
	List<String >? ipRange;

	UpdateServerIPListRequest({
		this.name,
		this.ipRange,
	});

	factory UpdateServerIPListRequest.fromJson(Map<String, dynamic> map) {
		return UpdateServerIPListRequest( 
			name: map['Name'],
			ipRange: map['IpRange'] != null ? map['IpRange'].cast<String>().toList() : null,
		);
	}

	Map<String, dynamic> toJson() {
		final map = Map<String, dynamic>();
		if(name != null)
			map['Name'] = name;
		if(ipRange != null)
			map['IpRange'] = ipRange;
		return map;
	}
}

class PasswordRuleResult {
	int minSize;
	bool uppercase;
	bool lowercase;
	bool numbers;
	bool specialCharacters;

	PasswordRuleResult({
		this.minSize = 0,
		this.uppercase = false,
		this.lowercase = false,
		this.numbers = false,
		this.specialCharacters = false,
	});

	factory PasswordRuleResult.fromJson(Map<String, dynamic> map) {
		return PasswordRuleResult( 
			minSize: map['MinSize'],
			uppercase: map['Uppercase'],
			lowercase: map['Lowercase'],
			numbers: map['Numbers'],
			specialCharacters: map['SpecialCharacters'],
		);
	}

	Map<String, dynamic> toJson() {
		final map = Map<String, dynamic>();
		map['MinSize'] = minSize;
		map['Uppercase'] = uppercase;
		map['Lowercase'] = lowercase;
		map['Numbers'] = numbers;
		map['SpecialCharacters'] = specialCharacters;
		return map;
	}
}


